;	 <This software is a set of multi media card functions. A rudimentary
;    command shell is used to acess those multi media card functions.>
;    Copyright (C) 2012  Kroetzl Stefan

;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License.

;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.

;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <http://www.gnu.org/licenses/>.
;
;	 Contact: http://www.kroetzl.at

.include "m8def.inc"		

.cseg						

.org 0x00
	rjmp reset

.include "./units/crc/crc.asm"
.include "./units/spi/spi.asm"
.include "./units/mmc/mmc.asm"
.include "./units/usart/usart.asm"

reset:						; this software is designed to run at 8 MHz

	ldi r16, low(RAMEND)	; set stackpointer
	out SPL, r16
	ldi r16, high(RAMEND)
	out SPH, r16

reset_gpio_initialization:

	ldi r16, 0xFF			; configure the ports
	out DDRB, r16

	ldi r16, 0x00
	out DDRD, r16

	ldi r16, 0x00
	out DDRC, r16

	rcall usart_initialization	; start initialization process

	

	rcall spi_initialization	 		
	rcall mmc_initialization

main:	

	ldi ZL, low(ready*2)	; set the Z pointer	
	ldi ZH, high(ready*2)

	rcall usart_send_string
	rcall usart_carriage_return	; 0x0D, 0x0A

	rcall usart_shell	; ready for next instruction

	rjmp main





cmd0: 
	.db 0x0D,0x0A,"CMD0   ",0x00,0x40,0x00,0x00,0x00,0x00,0x95
cmd1:
	.db 0x0D,0x0A,"CMD1   ",0x00,0x41,0x00,0x00,0x00,0x00,0xF9
cmd9:
	.db 0x0D,0x0A,"CMD9   ",0x00,0x49,0x00,0x00,0x00,0x00,0xAF
cmd10:
	.db 0x0D,0x0A,"CMD10  ",0x00,0x4A,0x00,0x00,0x00,0x00,0x1B
cmd58:
	.db 0x0D,0x0A,"CMD58  ",0x00,0x7A,0x00,0x00,0x00,0x00,0xFD
cmd59:
	.db 0x0D,0x0A,"CMD59  ",0x00,0x7B,0x00,0x00,0x00,0x01,0x83
ready:
	.db 0x0D,0x0A,"READY",0x00
crc:
	.db 0x0D,"CRC ERROR ",0x00
address:
	.db "ADDRESS ERROR",0x00
instruction:
	.db "CMD",0x00,low(usart_receive_instruction),high(usart_receive_instruction)
poll:
	.db "POLL",0x00,low(usart_receive_poll),high(usart_receive_poll),0x00
write:
	.db "WRITE",0x00,low(usart_receive_write),high(usart_receive_write)
licence:
	.db "mmc.hex Copyright (C) 2012 Kroetzl Stefan",0x0D,0x0A,"This program comes with ABSOLUTELY NO WARRANTY."," This is free software, and you",0x0D,0x0A,"are welcome to redistribute it under certain conditions. You should have",0x0D,0x0A,"received a copy of the GNU General Public License along with this program.",0x0D,0x0A,"If not, see <http://www.gnu.org/licenses/>. Press any key to continiue....",0x00



.dseg

mmc:		.byte	0x05
ocr:		.byte	0x01
cmd:		.byte	0x0A
cidcsd:		.byte	0x1F0	
stack:		.byte	0x200

