;	 <multi media card interface -> crc for atmega8 @ 8MHz>
;    Copyright (C) 2012  Kroetzl Stefan

;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License.

;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.

;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <http://www.gnu.org/licenses/>.
;
;	 Contact: http://www.kroetzl.at

;*******************************************************************************************************
;crc7:
;parameters:
;version: 0.1e
;*******************************************************************************************************

crc7:

	ldi ZL, low(mmc)
	ldi ZH, high(mmc)
	
	ld r23, Z+		; msb
	ld r22, Z+
	ld r21, Z+
	ld r20, Z+
	ld r19, Z+		; lsb
	ld r18, Z		; initialize 7bit shift register

	ldi r16, 0x09	; polynomial
	ldi r17, 0x2F	; number of left shifts

crc7_shift:

	lsl r19
	rol r20
	rol r21
	rol r22
	rol r23

	rol r18
	sbrc r18, 0x07
	eor	 r18, r16

	dec r17
	brne crc7_shift

crc7_return:

	lsl r18		
	inc r18
	
	st Z, r18		; crc7

	ret

;*******************************************************************************************************
;crc16:
;parameters: r16
;version: 0.1a
;*******************************************************************************************************

crc16:

	ldi r17, 0x08	; number of left shifts

	ldi r20, 0x21	; polynomial
	ldi r21, 0x10

crc16_shift:

	lsl r16

	rol r18			; 16bit shift register
	rol r19

	brcs crc16_eor_polynomial
	rjmp crc16_return

crc16_eor_polynomial:
	
	eor r18, r20
	eor r19, r21

crc16_return:

	dec r17
	brne crc16_shift

	ret
